// Marcelo Eiji Morioka
// Marcos Tatsuo Yamamoto
// Geometria Computacional
// Prof. Coelho
// Linguagem utilizada: Java (jdk 1.1.6)

import java.awt.*;
import java.awt.event.*;
import java.lang.*;
import java.io.*;
import java.util.*;

public class Principal extends Frame {
    java.awt.MenuBar mainMenuBar;
    java.awt.Menu menu1;
    int cont;
    public static Vector v, vetor;
    Canvas c;
    
    public Principal() {
	setTitle("Interseco de segmentos");
	setLayout(null);
	resize(400,300);
	mainMenuBar = new java.awt.MenuBar();
	menu1 = new java.awt.Menu("Funes");
	menu1.add("Verificar interseco pelo mtodo da varredura");
	menu1.add("Verificar interseco pelo mtodo burro");
	menu1.addSeparator();
	menu1.add("Limpar tela");
	menu1.addSeparator();
	menu1.add("Sair");
	mainMenuBar.add(menu1);
	setMenuBar(mainMenuBar);
	cont = 0;
	v = new Vector();
	c = new Canvas();
	c.resize(500,350);
	add(c);	
    }
    
    // metodo que trata o clique do mouse sobre a tela
    public void mouseClicked(Event e) {
	Ponto p = new Ponto();
	if (cont % 2 == 0) {
	    p.setX(e.x);
	    p.setY(e.y);
	}
	else {
	    Ponto q;
	    q = (Ponto)(v.elementAt(cont-1));

	    if (p.getX() < q.getX()) {
		p.setX(q.getX());
		p.setY(q.getY());
		q.setX(e.x);
		q.setY(e.y);
	    }
	    else {
		p.setX(e.x);
		p.setY(e.y);
	    }
		
	    // traca o segmento 
	    Graphics g = c.getGraphics();
	    g.setColor(Color.blue);
	    g.drawLine(p.getX(),p.getY(),q.getX(),q.getY());
	}
	v.addElement(p);
	cont++;
    }

    public boolean action(Event e, Object o) {
	if (e.target instanceof MenuItem) {
	    String label = (String) o;
	    if (label.equals("Verificar interseco pelo mtodo da varredura")) {
		System.out.println("Comecou varredura");
		InterSegmentos i = new InterSegmentos(v);
		vetor = i.Verifica();				
		Graphics g = c.getGraphics();
		for (int j = 0; j < vetor.size(); j++) {
		    Segmento s1 = (Segmento)(vetor.elementAt(j));
		    Ponto p1 = s1.getFirst();
		    Ponto p2 = s1.getLast();
		    g.setColor(Color.red);
		    g.drawLine(p1.getX(),p1.getY(),p2.getX(),p2.getY());
		    g.setColor(Color.black);
		}
		g.drawString("Nmero de comparaes da varredura: "+i.getContador(), 15, 280);
	    } 
	    else
		if (label.equals("Verificar interseco pelo mtodo burro")) {
		    System.out.println("Comecou ingnuo");
		    InterSegmentosBurro ib = new InterSegmentosBurro(v);
		    vetor = ib.Verifica();				
		    Graphics g = c.getGraphics();
		    for (int j = 0; j < vetor.size(); j++) {
			Segmento s1 = (Segmento)(vetor.elementAt(j));
			Ponto p1 = s1.getFirst();
			Ponto p2 = s1.getLast();
			g.setColor(Color.green);
			g.drawLine(p1.getX(),p1.getY(),p2.getX(),p2.getY());
			g.setColor(Color.black);
		    }
		    g.drawString("Nmero de comparaes do ingnuo: "+ib.getContador(), 15, 290);
		}
		else
		    if (label.equals("Limpar tela")) {
			Graphics g = c.getGraphics();
			g.setColor(Color.white);
			g.fillRect(0,0,500,350);
			// limpa o vetor
			v.removeAllElements();
			// zera o contador
			cont = 0;
		    }
		    else
			if (label.equals("Sair")) {
			    System.exit(0);
			    return true;
			}
	}
	return super.action(e, o);
    }
    
    public boolean handleEvent(Event e) {
	if (e.id == Event.WINDOW_DESTROY)
	    System.exit(0);
	else if (e.id == Event.MOUSE_UP)
	    mouseClicked(e);
	return super.handleEvent(e);
    }      
    
    public static void main(String argv[]) {
	Frame f = new Principal();
	f.show();
    }
}
