// Marcelo Eiji Morioka
// Marcos Tatsuo Yamamoto
// Geometria Computacional
// Prof. Coelho
// Linguagem utilizada: Java (jdk 1.1.6)


import java.io.*;

// classe que implementa um segmento formado pelos seus pontos extremos
public class Segmento {
    Ponto i;
    Ponto f;
    int key;
    
    // construtorzinho basico
    public Segmento(Ponto ini, Ponto fim, int key) {
	i = ini;
	f = fim;
	this.key = key;
    }
    
    // funcoes basicas de gets e sets

    public Ponto getFirst() {
	return (i);
    }
    
    public Ponto getLast() {
	return (f);
    }
    
    public void setKey(int k) {
	key = k;
    }
    
    public int getKey() {
	return (key);
    }
    
    public Ponto retornaPonto(int x) {
	double ms1;
	int y;
	Ponto p, p1, p2;
	
	p1 = this.getFirst();
	p2 = this.getLast();	
	ms1 = (double)(p2.getY() - p1.getY())/(p2.getX() - p1.getX());
	y = (int)(ms1*(x - p1.getX())+p1.getY());
	p = new Ponto(x, y);
	return(p);
    }

    // funcao que verifica a orientacao de um triangulo
    public int Orientacao(Ponto p3) {
	Ponto p1, p2; // pontos de s
	int det, x1, x2, x3, y1, y2, y3;
	
	p1 = this.getFirst();
	p2 = this.getLast();
	x1 = p1.getX();
	x2 = p2.getX();
	x3 = p3.getX();
	y1 = p1.getY();
	y2 = p2.getY();
	y3 = p3.getY();
	/*		System.out.println("det");
	System.out.println(x1+" "+y1);
	System.out.println(x2+" "+y2);
	System.out.println(x3+" "+y3);*/
	det = x1 * y2 + x3 * y1 + x2 * y3 - x3 * y2 - x2 * y1 - x1 * y3;
	//	System.out.println(det);
	return (det);
    }
}






